.nolist
include \masm32\include\masm32rt.inc
.686
include \masm32\macros\timers.asm		; get them from the [url=http://www.masm32.com/board/index.php?topic=770.0]Masm32 Laboratory[/url]
LOOP_COUNT	= 2000

GetFileLen1	PROTO: DWORD
GetFileLen2	PROTO: DWORD
GetFileLen3	PROTO: DWORD

.data
SizeA=148076
SizeB=15400
SizeC=849924
FileA	db "\masm32\m32lib\masm32.lib", 0
FileB	db "\masm32\m32lib\masm32.inc", 0
FileC	db "\masm32\include\Windows.inc", 0

.code
start:
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		.if rv(GetFileLen1, offset FileA)!=SizeA
			print str$(eax), " is incorrect (GetFileLen1 A)"
			exit
		.endif
		.if rv(GetFileLen1, offset FileB)!=SizeB
			print str$(eax), " is incorrect (GetFileLen1 B)"
			exit
		.endif
		.if rv(GetFileLen1, offset FileC)!=SizeC
			print str$(eax), " is incorrect (GetFileLen1 C)"
			exit
		.endif
	counter_end
	print str$(eax), 9, "cycles for 3*FindFirstFile", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		.if rv(GetFileLen2, offset FileA)!=SizeA
			print str$(eax), " is incorrect (GetFileLen2 A)"
			exit
		.endif
		.if rv(GetFileLen2, offset offset FileB)!=SizeB
			print str$(eax), " is incorrect (GetFileLen2 B)"
			exit
		.endif
		.if rv(GetFileLen2, offset FileC)!=SizeC
			print str$(eax), " is incorrect (GetFileLen2 C)"
			exit
		.endif
	counter_end
	print str$(eax), 9, "cycles for 3*GetFileAttributesEx", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		.if rv(GetFileLen3, offset FileA)!=SizeA
			print str$(eax), " is incorrect (GetFileLen3 A)"
			exit
		.endif
		.if rv(GetFileLen3, offset offset FileB)!=SizeB
			print str$(eax), " is incorrect (GetFileLen3 B)"
			exit
		.endif
		.if rv(GetFileLen3, offset FileC)!=SizeC
			print str$(eax), " is incorrect (GetFileLen3 C)"
			exit
		.endif
	counter_end
	print str$(eax), 9, "cycles for 3*GetFileSize", 13, 10

	inkey chr$(13, 10, "--- ok ---", 13)
	exit

GetFileLen1 proc fname
LOCAL wfd:WIN32_FIND_DATA
  call ClearLocVars
  push ebx
  lea ebx, wfd
  mov [ebx.WIN32_FIND_DATA.dwFileAttributes], FILE_ATTRIBUTE_NORMAL	
  invoke FindFirstFile, fname, ebx
  .if eax!=INVALID_HANDLE_VALUE
	invoke FindClose, eax
	mov eax, [ebx.WIN32_FIND_DATA.nFileSizeLow]
  .endif
  pop ebx
  ret
GetFileLen1 endp

GetFileLen2 proc fname
LOCAL wfad:WIN32_FILE_ATTRIBUTE_DATA
  call ClearLocVars
  push ebx
  lea ebx, wfad
  GetFileExInfoStandard = 0
  invoke GetFileAttributesEx, fname, GetFileExInfoStandard, ebx
  .if eax
	mov eax, [ebx.WIN32_FILE_ATTRIBUTE_DATA.nFileSizeLow]
  .endif
  pop ebx
  ret
GetFileLen2 endp

GetFileLen3 proc fname
  invoke CreateFile, fname, GENERIC_READ, FILE_SHARE_READ,
  NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0
  .if eax!=INVALID_HANDLE_VALUE
	push eax
	invoke GetFileSize, eax, 0
	xchg eax, [esp]
	invoke CloseHandle, eax
	pop eax
  .endif
  ret
GetFileLen3 endp

ClearLocVars proc	; put "call ClearLocals" as first instruction after LOCALS - eax unchanged on exit
  push eax		; do not use with uses esi etc - push them manually behind the call!
  lea eax, [esp+8]		; pushed eax and ret address
  mov esp, ebp		; base page of calling procedure
  align 4		; 74 instead of 123 cycles on Celeron M, no effect on P4
@@:
  push 0		; 120 bytes: 196 cycles on P4
  cmp esp, eax		; rep stosd??
  ja @B
  sub esp, 8		; 19 bytes with align 4
  pop eax
  ret
ClearLocVars endp
end start

RichMasm options:

OPT_Tmp2Asm	1
OPT_Assembler	ml
OPT_Wait	1

Check also the [url=\masm32\RichMasm\RES\TimingsMacro.asc]timings macro[/url]